const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Analytics_dailyDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const analytics_daily = await db.analytics_daily.create(
      {
        id: data.id || undefined,

        date: data.date || null,
        visits: data.visits || null,
        clicks: data.clicks || null,
        top_referrers: data.top_referrers || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await analytics_daily.setProfile_page(data.profile_page || null, {
      transaction,
    });

    await analytics_daily.setOrganizations(data.organizations || null, {
      transaction,
    });

    return analytics_daily;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const analytics_dailyData = data.map((item, index) => ({
      id: item.id || undefined,

      date: item.date || null,
      visits: item.visits || null,
      clicks: item.clicks || null,
      top_referrers: item.top_referrers || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const analytics_daily = await db.analytics_daily.bulkCreate(
      analytics_dailyData,
      { transaction },
    );

    // For each item created, replace relation files

    return analytics_daily;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const analytics_daily = await db.analytics_daily.findByPk(
      id,
      {},
      { transaction },
    );

    const updatePayload = {};

    if (data.date !== undefined) updatePayload.date = data.date;

    if (data.visits !== undefined) updatePayload.visits = data.visits;

    if (data.clicks !== undefined) updatePayload.clicks = data.clicks;

    if (data.top_referrers !== undefined)
      updatePayload.top_referrers = data.top_referrers;

    updatePayload.updatedById = currentUser.id;

    await analytics_daily.update(updatePayload, { transaction });

    if (data.profile_page !== undefined) {
      await analytics_daily.setProfile_page(
        data.profile_page,

        { transaction },
      );
    }

    if (data.organizations !== undefined) {
      await analytics_daily.setOrganizations(
        data.organizations,

        { transaction },
      );
    }

    return analytics_daily;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const analytics_daily = await db.analytics_daily.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of analytics_daily) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of analytics_daily) {
        await record.destroy({ transaction });
      }
    });

    return analytics_daily;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const analytics_daily = await db.analytics_daily.findByPk(id, options);

    await analytics_daily.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await analytics_daily.destroy({
      transaction,
    });

    return analytics_daily;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const analytics_daily = await db.analytics_daily.findOne(
      { where },
      { transaction },
    );

    if (!analytics_daily) {
      return analytics_daily;
    }

    const output = analytics_daily.get({ plain: true });

    output.profile_page = await analytics_daily.getProfile_page({
      transaction,
    });

    output.organizations = await analytics_daily.getOrganizations({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userOrganizations = (user && user.organizations?.id) || null;

    if (userOrganizations) {
      if (options?.currentUser?.organizationsId) {
        where.organizationsId = options.currentUser.organizationsId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.profile_pages,
        as: 'profile_page',

        where: filter.profile_page
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.profile_page
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  title: {
                    [Op.or]: filter.profile_page
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.organizations,
        as: 'organizations',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.top_referrers) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'analytics_daily',
            'top_referrers',
            filter.top_referrers,
          ),
        };
      }

      if (filter.dateRange) {
        const [start, end] = filter.dateRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            date: {
              ...where.date,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            date: {
              ...where.date,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.visitsRange) {
        const [start, end] = filter.visitsRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            visits: {
              ...where.visits,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            visits: {
              ...where.visits,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.clicksRange) {
        const [start, end] = filter.clicksRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            clicks: {
              ...where.clicks,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            clicks: {
              ...where.clicks,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          organizationsId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.organizationsId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.analytics_daily.findAndCountAll(
        queryOptions,
      );

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('analytics_daily', 'date', query),
        ],
      };
    }

    const records = await db.analytics_daily.findAll({
      attributes: ['id', 'date'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['date', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.date,
    }));
  }
};
